module subprop.

kind person	type.
kind int 	type.

type sigma   (A -> o) -> o.
type age     person -> int -> o.
type sublist (A -> o) -> (list A) -> (list A) -> o.

sublist P [X|L] [X|K] :- P X, !, sublist P L K.
sublist P [X|L] K :- sublist P L K.
sublist P [] [].

same_age L K :- sublist (Z\ (age Z A)) L K.

have_age L K :- sublist (Z\ (sigma X\ (age Z X))) L K.

have_parents L K :- sublist (Z\(sigma X\(sigma Y\ (father Z X, mother Z Y)))) L K.

have_parent L K :- sublist (Z\ (sigma X\ (father Z X ; mother Z X))) L K.

same_parents L K :- sublist (Z\ (father Z X, mother Z Y)) L K.

age john 24.
age mary 23.
age sue  24.
age bob  23.

father john sam.
father sue bob.
mother john mary.

test0 K :- have_parent [john, adam, sue, bob] K.
test1 K :- have_age [john, adam, sue, bob] K.
test2 K :- same_age [john, adam, sue, bob] K.
test3 K :- have_parents [john, adam, sue, bob] K.
test4 K :- same_parents [john, adam, sue, bob] K.

