module formulas.

%  This file provides some sample formulas for testing out our
%  theorem provers.

import logic.

kind	name		type.

type	formula		name -> bool -> o.

type    a               i.
type    b               i.
type	c		i.
type    v               i.
type    w               i.
type    x               i.
type    y               i.
type    z               i.
type	nil		i.
type	jar		i.


type    f               i -> i.
type    g               i -> i -> i.
type	cons		i -> i -> i.

type    pp              bool.
type    qq              bool.
type    rr              bool.
type    ss              bool.

type    p1              i -> bool.
type    p2              i -> bool.
type    p3              i -> bool.
type    p4              i -> bool.
type    p               i -> bool.
type    q               i -> bool.
type	prime		i -> bool.
type	green		i -> bool.
type	blue		i -> bool.
type	sterile		i -> bool.
type	dead		i -> bool.
type	animal		i -> bool.
type	bug		i -> bool.
type	heated		i -> bool.

type	in		i -> i -> bool.
type    r               i -> i -> bool.
type	divides		i -> i -> bool.
type	greater		i -> i -> bool.
type	on_top		i -> i -> bool.

type	app		i -> i -> i -> bool.

type	reflexive	name.
type	primes		name.
type	cases2		name.
type	modus_quant	name.
type	cases1		name.
type	distrib_quant	name.
type	baffler		name.
type	blocks		name.
type	imp_trans	name.
type	pierce		name.
type	bugs		name.
type	f11		name.
type	f12		name.
type	f13		name.
type	f14		name.
type	f15		name.
type	f16		name.
type	f22		name.

formula bugs
 (((heated jar) and (forall X\ ((bug X) imp (animal X))) and
   (forall X\ (forall Y\ (((heated Y) and (in X Y) and (animal X))
                            imp (dead X)))) and
   (forall Y\ ((forall X\ (((in X Y) and (bug X)) imp (dead X)))
    imp (sterile Y))))
  imp (sterile jar)).

formula pierce (((pp imp qq) imp pp) imp pp).

formula imp_trans ((pp imp qq) imp ((rr imp pp) imp (rr imp qq))).

formula blocks
 (((forall Z\ ((blue Z) imp (neg (green Z)))) and
   (blue c) and (green a) and (on_top b c) and (on_top a b) and
   (forall W\ ((neg (green W)) or (green W))))
  imp (exists X\ (exists Y\ ((on_top X Y) and
                             (neg (green Y)) and (green X))))).

formula baffler (exists X\ (forall Y\ ((p X) imp (p Y)))).

formula distrib_quant ((forall X\ ((q X) or rr)) imp
		       ((forall X\ (q X)) or rr)).
 
formula cases1 (((q a) or (q b)) imp (exists X\ (q X))).

formula modus_quant
(((p a) and (forall X\ ((p X) imp (q X)))) imp (exists X\ (q X))).

formula cases2
((((p a) or (q b)) and (forall X\ ((p X) imp (q X)))) imp
 (exists X\ (q X))).

formula f11
((forall X\ (r X X)) imp
 (forall U\ ((forall W\ ((r U W) imp forall V\ ((r W V) imp (p V))))) imp
	     (forall W\ ((r U W) imp (p W))))).

formula f12
(forall U\ ((forall W\ ((r U W) imp ((p W) imp (q W)))) imp
	    ((forall W\ ((r U W) imp (p W))) imp
	     (forall W\ ((r U W) imp (q W)))))).

formula f13
(((forall X\ (forall Y\ ((r X Y) imp (r X X)))) and
  (forall Y\ ((q Y) imp (exists Z\ (r Y Z)))) and (exists X\ (q X))) imp
 (exists X\ (exists Y\ ((q Y) and (r X Y))))).

formula f14 ((((rr and qq) imp ss) and (pp imp rr) and
	      (pp imp qq) and pp) imp ss).

formula f15
((exists X\ (forall Y\ (((p Y) imp (p X)) and ((p X) imp (p Y))))) imp
 (((forall Y\ (p Y)) imp (exists X\ (p X))) and
  ((exists X\ (p X)) imp (forall Y\ (p Y))))).

formula f16
(((forall X\ (forall L\ (forall K\ (forall M\
   ((app L K M) imp (app (cons X L) K (cons X M))))))) and
  (forall K\ (app nil K K))) imp
 (exists X\ (app (cons a (cons b nil)) (cons c nil) X))).

formula primes
 (((forall N\ ((neg (prime N)) or (prime N))) and
   (forall X\ (greater (f X) X)) and
   (forall X\ (forall Y\ ((divides X (f Y)) imp (greater X Y)))) and
   (forall X\
     ((neg (prime X)) imp (exists Y\ ((prime Y) and (divides Y X))))))
  imp (forall N\ (exists X\ ((greater X N) and (prime X))))).

formula reflexive
 (((forall X\ (forall Y\ (forall Z\ (((r X Y) and (r Y Z)) imp (r X Z)))))
   and (forall X\ (forall Y\ ((r X Y) imp (r Y X))))) imp
  (forall X\ ((exists Y\ (r X Y)) imp (r X X)))).

formula f22
(((forall X\ ((p4 X) imp (p3 X))) and (forall X\ ((p2 X) imp (neg (p3 X))))
  and (forall X\ ((p1 X) imp (p2 X)))) imp
 (forall X\ ((p1 X) imp (neg (p4 X))))).
