module inter.

%  A top-level interactive tactical theorem prover is defined
%  below.

import ndtac tacticals formulas.

kind	mod		type.

type	inter_top	name -> proof_object -> goal -> o.
type	inter		goal -> goal -> o.
type	do		o -> goal -> goal -> o.
type	load_tacs	mod -> goal -> goal -> o.
type	quit		goal -> goal -> o.
type	backup		goal -> goal -> o.
type	print_form_list	list judgment -> int -> o.

inter_top Name P OutGoal :- formula Name Formula,
  inter ([] --> P :: Formula) OutGoal.

inter (Gamma --> P :: A) NewGoal :-
  nl, writesans 'Assumptions: ',
  nl, print_form_list Gamma 1,
  nl, writesans 'Conclusion: ',
  nl, write A, nl,
  writesans 'Enter tactic: ', read Tac,
  ((Tac = backup), !, fail;
   (Tac = quit), (NewGoal = (Gamma --> P :: A));
   (Tac = load_tacs M : mod),
        load M, M => (inter (Gamma --> P :: A) NewGoal);
   (Tac = do G), G, inter (Gamma --> P :: A) NewGoal;
   Tac (Gamma --> P :: A) MidGoal,
   maptac inter MidGoal NewGoal;
   inter (Gamma --> P :: A) NewGoal).

print_form_list [] N.
print_form_list [P :: A | Tail] N :-
  write N, writesans ' ', write A, nl,
  (N1 is (N + 1)),
  print_form_list Tail N1.
