module meta_ex.

import meta_types meta.

kind  nat  type.

type z nat.
type s nat -> nat.
type pl nat -> nat -> nat.
type one nat.

type fib nat -> nat -> o.
type m_fib nat -> nat -> prop.

type app (list A) -> (list A) -> (list A) -> o.
type m_app (list A) -> (list A) -> (list A) -> prop.

type equ A -> A -> o.
type m_equ A -> A -> prop.

equ X X.

p_equ (lforall X\(m_equ X X)).
g_equ1 (lforall X\ (lexists Y\ (m_equ X Y))).
g_equ2 (lexists Y\ (lforall X\ (m_equ X Y))).

app [] K K.
app [X|L] K [X|M] :- app L K M.

p_app (   lforall K\(m_app [] K K)
     land (lforall L\ (lforall K\ (lforall M\ (lforall X\
	    ( m_app L K M limp
	      m_app [X|L] K [X|M] )))))
       ).

g_app1 L (m_app [1] [2] L).
g_app2 M (m_app l k m limp m_app [1,2|l] k M).
g_app3 L K (m_app L K [1,2,3]).

% fib accepts unary natural numbers as the first arguments and
% returns an answer in terms of plus and one.

fib z one.
fib (s z) one.
fib (s (s N)) (pl M1 M2) :- fib (s N) M1, fib N M2.
% This next version of the last clause should be more efficient, though still
% not linear.  It is represented in the second program.  Nested
% ':-' (implication) in the program is not really necessary.
% Linear complexity can be achieved using implication differently.
% See Dale Miller: "A theory of modules  for logic programming".
% (fib (s (s N)) (pl M1 M2) :- (fib N M2 => fib (s N) M1)) :- fib N M2.

p_fib1 (    m_fib z one
      land  m_fib (s z) one
      land  (lforall N\ (lforall M1\ (lforall M2\ 
	     (m_fib N M2 land m_fib (s N) M1
	       limp m_fib (s (s N)) (pl M1 M2)))))
     ).

p_fib2 (    m_fib z one
      land  m_fib (s z) one
      land  (lforall N\ (lforall M1\ (lforall M2\ 
	     (m_fib N M2 limp (m_fib N M2 limp m_fib (s N) M1)
	       limp m_fib (s (s N)) (pl M1 M2)))))
     ).

g_fib1 M (m_fib (s (s (s z))) M).
g_fib2 M (m_fib (s (s (s (s (s z))))) M).
