
%   Predicates in Lambda Prolog that define some of the `higher-order'
%   mapping operations

module	maps.

type	map		(A -> A) -> B -> B -> o.
type	mapfun		(A -> B) -> (list A) -> (list B) -> o.
type	mappred		(A -> B -> o) -> (list A) -> (list B) -> o.
type	reduce		(A -> B -> B) -> (list A) -> B -> B -> o.
type	reduce_pred	(A -> B -> o) -> (list A) -> (B -> B -> B) -> B -> o.
type	for_each	(A -> o) -> (list A) -> o.


% This mapping operation is a strange one.
map F (P R) (Q (F R)) :- map F P Q.
map F P P.

mapfun F [] [].
mapfun F [X|L] [(F X)|K] :- mapfun F L K.

mappred P [] [].
mappred P [X|L] [Y|K] :- P X Y, mappred P L K.

reduce F [] X X.
reduce F [W|L] X (F W Y) :-  reduce F L X Y.

reduce_pred P [W] F Y :- P W Y.
reduce_pred P [W|L] F (F Y Z) :- P W Y, reduce_pred P L F Z.

for_each P [].
for_each P [X|L] :- P X, for_each P L.


