
%  Below are some high-level stream manipulation functions written in
%  the functional programming language included in lambda Prolog.
%  These function are simply illustrations of what can be written.
%  We make no serious us of these functions.  The file exps.mod
%  shows how they can be used.

module streams.

type	chop		(A1 -> bool) -> stream A1 -> list A1.
type	iterate		(A1 -> A2 -> A2) -> A2 -> list A1 -> A2.
type	filter		(A1 -> bool) -> stream A1 -> stream A1.
type	map_stream	(A1 -> A2) -> stream A1 -> stream A2.


defun map_stream
  (fixpt (Map\F\L\ (if (null_stream L) snil 
		     (scons (F (head L)) 
			    (Map F (tail L)))))).
defun filter
  (fixpt (Filter\Pred\L\  
	  (if (null_stream L) snil
	    (if (Pred (head L))
		(scons (head L) (Filter Pred (tail L)))
	      (Filter Pred (tail L)))))).

defun iterate
  (fixpt Iterate\Fun\InitVal\List\
	 (if (null List) InitVal
	   (Fun (car List) (Iterate Fun InitVal (cdr List))))).

defun chop
  (fixpt (Chop\Pred\L\  
	  (if (null_stream L) []
	    (if (Pred (head L))
		[(head L)|(Chop Pred (tail L))] [])))).

