% This is the version of tp_simple that runs in
% LambdaProlog version 2.6.  Instead of using implication,
% it uses lists.
% It is somewhat convoluted in order to be compatible with tp_simple.
module tp_simple.

import tp_types.

kind  vtpair	type.

type  vt	term -> tp -> vtpair.

type  termtype term -> term -> tp -> o.
type  vartype    term -> tp -> o.
type  contype    term -> tp -> o.      % external.

type  termtype_e  term -> term -> tp -> (list vtpair) -> o.
type  vartype_e   term -> tp -> (list vtpair) -> o.

termtype U V Alpha :- termtype_e U V Alpha [].

% termtype_e U V Alpha E
% is as described in tp_simple, except that the additional argument
% E is an environment of terms of type 'vtpair' giving types to bound
% variables.

termtype_e (olam     U) (lam Beta V) Alpha E :- !,
  Alpha =  (Beta ==> Gamma),
  (pi X\ (termtype_e (U X) (V X) Gamma [(vt X Beta)|E])).

termtype_e (lam Beta U) (lam Beta V) Alpha E :- !,
  Alpha =  (Beta ==> Gamma),
  (pi X\ (termtype_e (U X) (V X) Gamma [(vt X Beta)|E])).

termtype_e (U0 @ U1) (V0 @ V1) Alpha E :- !,
  termtype_e U0 V0 (Beta ==> Alpha) E,
  termtype_e U1 V1 Beta E.

% Next clause for compatibility with tp_simple.
termtype_e X X Alpha E :- vartype X Alpha.

termtype_e X X Alpha E :- vartype_e X Alpha E.

termtype_e C C Alpha E :- contype C Alpha.

% Occurences of variables in the environment are unique, since
% they are created through quantification with pi.

vartype_e X Alpha [(vt X Beta) | E] :- !, Alpha = Beta.
vartype_e X Alpha [VT | E] :- vartype_e X Alpha E.
