% A formulation of the simply typed lambda calculus in which
% types may be omitted.

module tp_types.

infix 110 ==>   xfy.	% right associative: function types.
infix 120 @     yfx.	% left associative: application.

kind  tp        type.   % types.
kind  term      type.   % terms.

type  ==>       tp -> tp -> tp.   % function type constructor.

type  lam       tp -> (term -> term) -> term.  % lambda.
type  olam      (term -> term) -> term.	       % type omitted.
type  @         term -> term -> term.	       % application.
