% These declarations for used to implement the various data structures
% and operations on them to be used within Lambda Prolog and in its
% functional interpreter.

% This is a system module.  Do not import this one directly.

module	fp_sys.

infix  40 <   xfx.
infix  40 =<  xfx.
infix  40 >   xfx.
infix  40 >=  xfx.
infix  21 *   yfx.
infix  31 +   yfx.
infix  31 -   yfx.
infix  21 div yfx.
infix  11 mod xfx.
infix  50 seq xfy.

kind unit    type.
kind bool    type.
kind int     type.
kind list    type -> type.
kind stream  type -> type.
kind pair    type -> type -> type.

type pair    A -> B -> (pair A B).

% Constants used internally to implement lists. Before changing these names
% change list_cons and list_nil in initial.pro
type internalnil	list A.
type internalcons	A -> (list A) -> (list A).

type unit    unit.
type seq     A -> B -> unit.

type equal   A -> A -> bool.
type truth   bool.
type false   bool.
type and     bool -> bool -> bool.
type or      bool -> bool -> bool.
type zerop   int -> bool.

type consp   (list A) -> bool.
type car     (list A) -> A.
type cdr     (list A) -> (list A).
type null    (list A) -> bool.

type first   (pair A B) -> A.
type second  (pair A B) -> B.
type pairp   (pair A B) -> bool.

type if      bool -> A -> A -> A.
type fixpt  (A -> A) -> A.

type error   A.

type snil    (stream A).
type scons   A -> (stream A) -> (stream A).
type head    (stream A) -> A.
type tail    (stream A) -> (stream A).
type null_stream (stream A) -> bool.

type <       int -> int -> bool.
type =<      int -> int -> bool.
type >       int -> int -> bool.
type >=      int -> int -> bool.
type +       int -> int -> int.
type -       int -> int -> int.
type *       int -> int -> int.
type div     int -> int -> int.
type mod     int -> int -> int.

type print        A -> unit.
type print_sans   string -> unit.
type blanklines   int ->  unit.

% This is the interface to the logic programming environment
type choose  (A -> o) -> A.
